%define ALD_Ver		2.0

Name:         flex

License:      BSD
Summary:      This is flex, the fast lexical analyzer generator.
Version:      2.6.4
Release:      0

# https://github.com/westes/flex

Source: %{name}-%{version}.tar.xz

%define DestDir		/Compiler
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
GNU make command
# --------------------------------------
%package info
Summary:      Info for %{name}
%description info
Info for %{name}

# ------------------- setup ------------------------------------------
%Prep
%setup -q

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
export  PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -fno-asynchronous-unwind-tables -fno-stack-protector"

CFLAGS="$OPTFLAGS -std=gnu99 -fPIC"
LDFLAGS="-Wl,--gc-sections"
CXXFLAGS="$OPTFLAGS"

%configure \
	--disable-shared \
	--enable-static \
	--disable-nls \
	--disable-rpath \
	&>FConfigure_log.txt

make -C src libfl.la &>FMake_log_lib.txt

CFLAGS="$OPTFLAGS -std=gnu99"

%configure \
	--disable-shared \
	--enable-static \
	--disable-nls \
	--disable-rpath \
	&>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export  PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt

cp THANKS $RPM_BUILD_ROOT%{docdir}/

rm -rf $RPM_BUILD_ROOT%{_infodir}/dir
rm $RPM_BUILD_ROOT%{docdir}/ONEWS
rm $RPM_BUILD_ROOT%{docdir}/NEWS

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_bindir}
%{_libdir}
%{_includedir}
%{_mandir}
%exclude %{docdir}/*.pdf
%{docdir}

%files info
%{_infodir}

